<?php

//~ returns two scafolding classes
function b2046_scafolding($value, $custom_class){ // custom_class will come with when will work the multi input
	$out = array('','');
	if(isset($value)){
		if ($value == '1'){
			 //~ Hard definied just for now
			$out[0] = 'row';
			$out[1] = 'span12';
		}elseif($value == '2'){
			$out[0] = '';
			$out[1] = 'row';
		}
	}else{
		$out[0] = '';
		$out[1] = '';
	}
	return $out;
}


//~ 
//~ 
//~ ONTROL FUNCTIONS - creates front end content
//~ *
//~

 //~ change number of posts to be seen 
function b2046_post_number($tmp_query, $values){
	$output = array();
	$args = array(
		'posts_per_page' => (int)$values
		);
		//~ rewrite the default data with our own
	$output = $args;
	return $output;
}

function b2046_sticky($tmp_query, $values){
	$output = array();
	
	// if we want to hide sticky (1), otherwise (0) show
	if($values[0] == 1){
		$args = array(
			'ignore_sticky_posts' => true,
		);
	}else{
		$args = array();
		//~ rewrite the default data with our own
	}
	$output = $args;
	return $output;
}

//~ offset posts
function b2046_post_offset($tmp_query, $values){
	$output = array();
	$args = array(
		'offset' => $values
		);
		//~ rewrite the default data with our own
	$output = $args;
	return $output;
}
//~ offset posts
function b2046_show_by_date($tmp_query, $values){
	$output = array();
	$year = $values[0];
	$month = $values[1];
	$week = $values[2];
	$day = $values[3];
	$before = $values[4];
	$after = $values[5];

	if (!empty($year)){$args = array('date_query' => array(array('year'  => $year)));};
	if (!empty($month)){$args = array('date_query' => array(array('month'  => $month)));};
	if (!empty($week)){$args = array('date_query' => array(array('week'  => $week)));};
	if (!empty($day)){$args = array('date_query' => array(array('day'  => $day)));};
	if (!empty($before)){$args = array('date_query' => array(array('year'  => $before)));};
	if (!empty($after)){$args = array('date_query' => array(array('after'  => $after)));};

	$output = $args;
	return $output;
}

function b2046_taxonomy_parameters($tmp_query, $values){
	$output = array();
	//~ 0 - taxonomy
	//~ 1 - terms
	//~ 2 - term operator
	//~ 3 - taxonomy relation
	if(!empty($values[0]) && !empty($values[1])){
		$taxonomy = Easy_2046_builder::f2046_id_cleaner_to_array($values[0]);
		$the_only_taxonomy = $taxonomy[0];
		$terms = Easy_2046_builder::f2046_id_cleaner_to_array($values[1]);
		$args =  array(
			'tax_query' => array(
				'relation' => $values[3], 
				array(
					'taxonomy' => $the_only_taxonomy,
					'field' => 'id',
					'terms' => $terms,
					'operator' => $values[2]
					)
				)
			);
		$output = array_merge( $output, $args);
	}
	return $output;
}
function b2046_based_on_actual_taxonomy($tmp_query, $values){
	$output = array();
	$taxonomy = !empty($values[0]) ? $values[0] : 'category';
	$operator = $values[1];
	$relation = $values[2];
	global $post;
	
	$term_list = wp_get_post_terms($post->ID, $taxonomy, array("fields" => "ids"));
	$args =  array(
		'tax_query' => array(
			'relation' => $relation, 
			array(
				'taxonomy' => $taxonomy,
				'field' => 'id',
				'terms' => $term_list,
				'operator' => $operator
				)
			)
		);

	$output = array_merge( $output, $args);
	return $output;
}

function b2046_meta($tmp_query, $values){
	$output = array();
	$args = array();
	$key = $values[0];
	$vals = $values[1];
	$type = $values[2];
	$compare = $values[3];
	$compare_choices = array(
		'0' => '=',
		'1' => '!=',
		'2' => '>',
		'3' =>  '>=',
		'4' =>  '<',
		'5' =>  '<=',
		'6' =>  'LIKE',
		'7' =>  'NOT LIKE',
		'8' =>  'IN',
		'9' =>  'NOT IN',
		'10' =>  'BETWEEN',
		'11' =>  'NOT BETWEEN',
		'12' =>  'EXISTS',
		'13' =>  'NOT EXISTS'
	);
	$relation = $values[4];
	// if the query has the meta call already, join the actual one to the existing one
	if (isset($tmp_query['meta_query'])){
		// revrite the realition to the actual one
		$tmp_query['meta_query']['relation'] = $relation;
		// define next meta query
		$args_tmp = array(
			'key' => $key,
          	'value' => $vals, //array(3, 4),
          	'type' => $type,
          	'compare' => $compare_choices[$compare]
		);
		// add thew new meta query to the existing
		array_push($tmp_query['meta_query'], $args_tmp);
		// create the args
		$args = array("meta_query" => $tmp_query['meta_query']);
	}else{
		$args = array(
	   // 'meta_key' => 'age',
		'meta_query' => array(
			'relation' => $relation,
			array(
				'key' => $key,
	          	'value' => $vals, //array(3, 4),
	          	'type' => $type,
	          	'compare' => $compare_choices[$compare],
	           )
			)
		);
	}
	// $output = $output + $args;
	$output = array_merge($output, $args);
	return $output;
}

function b2046_based_on_actual_meta($tmp_query, $values){
	$output = array();
	return $output;
}

//~ Change post type
function b2046_post_type($tmp_query, $values){
	$output = array();
	global $post;
	$paged = (get_query_var('paged')) ? get_query_var('paged') : 1;
	//~ post type

	$args = array(
		'post_type' => $values[0]
		);
	$output = array_merge( $output, $args);

	if($values[1] == 1){
		$paged = array(
			'paged' => $paged
			);
		$output = array_merge( $args , $paged);
	}
	
	return $output;
}
//~  post status
function b2046_post_status($tmp_query, $values){
	$output = array();
	$args = array(
		'post_status' => $values
		);
		//~ rewrite the default data with our own
	$output =  $args;
	return $output;
}
//~ category control
function b2046_category_controls($tmp_query, $values){
	$output = array();
	$control = $values[0];
	$cats = $values[1];
	if($control == 'cat'){
		$putre_cat_ids = Easy_2046_builder::f2046_id_cleaner_to_string($cats);
	}else{
		$putre_cat_ids = Easy_2046_builder::f2046_id_cleaner_to_array($cats);
	}
	$args = array(
		$control => $putre_cat_ids
		);
	//~ rewrite the default data with our own
	$output =  $args;
	return $output;
}

//~ 
//~ Control order
//~ 
function b2046_order($tmp_query, $values){
	$order = $values[0];
	$order_by = $values[1];
	$meta_key = $values[2];
	$args = array(
		'order' => $order,
		'orderby' => $order_by
	);
	if(!empty($meta_key)){
		$args['meta_key'] = $meta_key;
	}
	return $args;
}


//~ 
//~ 
//~ VIEW FUNCTIONS - creates front end content
//~ *
//~ 

//~ This extension si to build the title of the desired object
function b2046_post_title($easy_query, $values){
	$link = $values[0];
	$scafold = $values[1];
	$target = ($values[2] == 'blank') ? ' target="_blank"' : '';
	if(!empty($values[3])){
		$customlink = get_post_meta($easy_query->post->ID, $values[3], true);
	}else{
		$customlink = '';
	}
	$class = $values[4]; 
	$out = '';

	if($scafold != '0'){
		$out .= '<'.$scafold.' class="'.$class.'">';
	}
	
	if($link == 0){
		$out .= get_the_title($easy_query->post->ID);
	}elseif(!empty($customlink)){
		$out .= '<a href="'.$customlink.'" '.$target.'>'.get_the_title($easy_query->post->ID).'</a>';
	}else{
		$out .= '<a href="'.get_permalink($easy_query->post->ID).'" '.$target.'>'.get_the_title($easy_query->post->ID).'</a>';
	}
	
	if($scafold !='0'){
		$out .= '</'.$scafold.'>';
	}

	return $out;
}
function b2046_sidebar($easy_query, $values){
	$out = '';

	if(!empty($values[0])){
		$out = get_dynamic_sidebar($values[0]);
	}
	return $out;
}
function b2046_post_author($easy_query, $values){
	$linkType = $values[0];
	$linkVar = $values[1]; 
	$class = $values[2]; 
	$link_choices = array( 
		0 => 'ID',
		1 => 'user_login',
		2 => 'user_nicename',
		3 => 'user_email',
		4 => 'user_url',
		5 => 'display_name'
		);
	$out = '';
	$user = get_userdata($easy_query->post->post_author);

	$out .= '<div class="'.$class.' '.$easy_query->post->display_name.'">';

	// plain text
	if($linkType == 0){
		$out .= $user->$link_choices[$linkVar];
	}
	// link to authors post archive
	elseif($linkType == 1){
		$out .= '<a href="'.get_author_posts_url( $easy_query->post->post_author).'">'.$user->$link_choices[$linkVar].'</a>';
	}
	// link to authors url
	else{
		$out .= '<a href="'.$user->user_url.'">'.$user->$link_choices[$linkVar].'</a>';
	}
	
	$out .= '</div>';

	return $out;
}

//~ This extension si to build contet or excerpt,...
function b2046_post_content($easy_query, $values){
	$content_type = $values[0];
	$readmore = $values[1];
	$class = $values[2];
	$morestring = '<!--more-->';
	$out = '<div class="entry-content '.$class.'">';
	if($content_type == 'content'){
		$out .= (!empty($readmore)) ? apply_filters('the_content',get_the_content(__($readmore))) : apply_filters('the_content',get_the_content());
	}
	elseif($content_type == 'excerpt'){
		global $post;
		$a_link = '<a class="more-link" href="'.get_permalink($post->ID).'">'.__($readmore).'</a>';
		$out .= (!empty($readmore)) ? get_the_excerpt().$a_link : get_the_excerpt();
	}
	elseif($content_type == 'above'){
		global $post;
		$explodemore = explode($morestring, $post->post_content);
		$out .= $explodemore[0];
		$out .= (!empty($readmore)) ? '<a class="more-link" href="'.get_permalink($post->ID).'">'.__($readmore).'</a>' : '';
	}
	elseif($content_type == 'below'){
		global $post;
		$explodemore = explode($morestring, $post->post_content);
		$out .= $explodemore[1];
		$out .= (!empty($readmore)) ? '<a class="more-link" href="'.get_permalink($post->ID).'">'.__($readmore).'</a>' : '';
	}
	$out .= '</div>';
	return $out;
}
//~ VIEW - List post categories
function b2046_post_taxonomies($easy_query, $values){
	$out = '';
	if(!empty($values[1])){
		$user_given_taxonomy = Easy_2046_builder::f2046_id_cleaner_to_array($values[1]);
		$taxonomy = $user_given_taxonomy[0];
		$cat_count = $values[2];
		if(!empty($values[3])){
			$class = $values[3];
		}else{
			$class = '';
		}
		$terms = wp_get_post_terms( $easy_query->post->ID, $taxonomy, array("fields" => "all") );
		//~  if the user want to see the result as links
		if($values[0] == 0){
			if(!empty($class)){
				$out .='<div class="'.$class.'">';
			}
			foreach($terms as $c){
				$tax = get_term( $c, $taxonomy );//get_category( $c );
				if($cat_count == 1){
					$count = ' ('.$tax->count.')';
				}else{
					$count= '';
				}
				$tax_link = get_term_link( $c, $taxonomy );//get_category_link($c);
				$out .= '<a href="'.$tax_link.'">'.$tax->name.'</a>'.$count;
				if (end($terms) != $c){
					$out .= ', ';
				}
			}
			if(!empty($class)){
				$out .='</div>';
			}
		}
		//~  if the user want to see the result as list
		else{
			$out .= '<ul class="'.$class.'">';
			foreach($terms as $c){
				$tax = get_term( $c, $taxonomy );
				if($cat_count == 1){
					$count = ' ('.$tax->count.')';
				}else{
					$count= '';
				}
				
				$tax_link = get_term_link( $c, $taxonomy );
				$out .= '<li class="'.$tax->slug.'"><a href="'.$tax_link.'">'.$tax->name.'</a>'.$count.'</li>';
			}
			$out .='</ul>';
		}
	}
	return $out;
}

//~ edit link
function b2046_edit_link($easy_query, $values){
	$value = $values[0];
	$class = $values[1];
	$out = '';
	$link =  get_edit_post_link($easy_query->post->ID);
	if(is_user_logged_in()){
		if($value == 0){
			$out = '<a class="edit_link '.$class.'" href="'.$link.'">'.__('Edit').'</a>';
		}else{
			$out = '<span class="edit_link '.$class.'"><a href="'.$link.'">'.__('Edit').'</a> '.$easy_query->post->ID.'</span>';
		}
	}
	return $out;
}

//~ get images
//~ 
function b2046_post_image($easy_query, $values){
	$image = $values[0];
	$link = $values[1];
	$target = ($values[2] == 'blank') ? ' target="_blank"' : '';
	if(!empty($values[3]) && $link != 'url'){
		$customlink = get_post_meta($easy_query->post->ID, $values[3], true);
	}elseif(!empty($values[3]) && $link == 'url'){
		$customlink = $values[3];
	}else{
		$customlink = '';
	}
	$class = $values[4];
	$out = '';

	$att_id = get_post_thumbnail_id($easy_query->post->ID);
	
	if($link == 'objectlink'){
		$url = get_permalink($easy_query->post->ID);
	}elseif($link == 'customlink' || $link == 'url'){
		$url = $customlink;
	}elseif($link != 'nolink'){
		$img_obj = wp_get_attachment_image_src( $att_id, $link);
		$url = $img_obj[0];
	}	
	if(!empty($att_id)){
		$image_url = wp_get_attachment_image_src( $att_id, $image);
		if(!empty($class)){
			$out .= '<div class="'.$class.'">';
		}
		//  create link if any
		
		if(!empty($url)){
			if($link == 'objectlink' || $link == 'customlink' || $link == 'url' ){
				$out .= '<a href="'.$url.'" '.$target.'>';
			}
		}
		// render out the picture
		$out .= '<img src="'.$image_url[0].'" alt="'.get_the_title($easy_query->post->ID).'" />';
		// close the link
		if(!empty($url)){
			if($link == 'objectlink' || $link == 'customlink' || $link == 'url'){
				$out .= '</a>';
			}
		}

		if(!empty($class)){
			$out .= '</div>';
		}
	}
	return $out;
}

//~ get images
//~ 
function b2046_ACF_imageID_to_image($easy_query, $values){
	$field_name = intval($values[0]); // field name 
	$image = $values[1]; // image size
	$link = $values[2]; // link type .. post, image ,..
	$target = ($values[3] == 'blank') ? ' target="_blank"' : ''; // href target 
	$cf_ = $values[4];
	$class = $values[5]; // class

	if(!empty($$cf_) && $link != 'url'){
		$customlink = get_post_meta($easy_query->post->ID, $$cf_, true);
	}elseif(!empty($$cf_) && $link == 'url'){
		$customlink = $$cf_;
	}else{
		$customlink = '';
	}
	$out = '';

	$att_ = get_post_meta($easy_query->post->ID, $field_name, true);
	$att_id = $att_['featured_image'][0];
	
	
	if($link == 'objectlink'){
		$url = get_permalink($easy_query->post->ID);
	}elseif($link == 'customlink' || $link == 'url'){
		$url = $customlink;
	}elseif($link != 'nolink'){
		$img_obj = wp_get_attachment_image_src( $att_id, $link);
		$url = $img_obj[0];
	}	
	if(!empty($att_id)){
		$image_url = wp_get_attachment_image_src( $att_id, $image);
		if(!empty($class)){
			$out .= '<div class="'.$class.'">';
		}
		//  create link if any
		
		if(!empty($url)){
			if($link == 'objectlink' || $link == 'customlink' || $link == 'url' ){
				$out .= '<a href="'.$url.'" '.$target.'>';
			}
		}
		// render out the picture
		$out .= '<img src="'.$image_url[0].'" alt="'.get_the_title($easy_query->post->ID).'" />';
		// close the link
		if(!empty($url)){
			if($link == 'objectlink' || $link == 'customlink' || $link == 'url'){
				$out .= '</a>';
			}
		}

		if(!empty($class)){
			$out .= '</div>';
		}
	}
	return $out;
}

//~ gel n images form the post
function b2046_post_images($easy_query, $values){
	$image = $values[0];
	$link = $values[1];
	$order = $values[2];
	$orderby = $values[3];
	$title_value = $values[4];
	$featured_image_showhide = $values[5];
	$class = $values[6];
	$out = '';
	//~ get all posts based on the user query
	//~ get all its IDs and make arrayy late used as parent pages
	$the_query = new WP_Query($easy_query->query);

	$g_args =array(
		'post_parent' => $the_query->post->ID,
		'post_status' => 'inherit',
		'post_type' => 'attachment',
		'post_mime_type' => 'image',
		'order' => $order,
		'orderby' => $orderby
		);
	// if the do NOT want to include featured image in the gallery
	if($featured_image_showhide == 1){
		$g_args['post__not_in'] = array(get_post_thumbnail_id( $easy_query->post->ID ));
	}
	if($the_query->have_posts()){
		while ( $the_query->have_posts() ) : $the_query->the_post();
		$attachments = get_children($g_args);

			//~ process all found
		foreach($attachments as $key => $val) {
			if(!empty($val->ID)){
				$image_url = wp_get_attachment_image_src( $val->ID, $image);
				$img_obj = wp_get_attachment_image_src( $val->ID, $link);
				$url = $img_obj[0];

				if(!empty($class)){
					$out .= '<div class="'.$class.'">';
				}
				if($link != 'nolink'){
					$out .= '<a href="'.$url.'">';
				}
				$the_title = '';
				if ($title_value == 1){
					$the_title = $val->post_title;
				}elseif($title_value == 2){
					$the_title = $val->post_excerpt;
				}
				$out .= '<img src="'.$image_url[0].'" title="'.$the_title.'" alt="'.$val->post_title.'" />';
				if($link != 'nolink'){
					$out .= '</a>';
				}
				if(!empty($class)){
					$out .= '</div>';
				}
			}
		}
		endwhile;
	}
	// Reset Post Data
	wp_reset_postdata();
	
	return $out;
}
//~ 
//~ CONTROL - finds the actual post id and ad it to the query
//~ 
function b2046_for_actual_postid($tmp_query, $values){
	global $post;
	
	$args = array(
		'post__in' => array($post->ID),
		'post_type' => $post->post_type
		);
	return $args;
}

//~ 
//~ VIEW - custom meta data
//~ 
function b2046_object_meta($easy_query, $values){
	$out = '';
	$show_as = $values[0];
	$meta_key = $values[1];
	$separator = $values[2];
	$class = $values[3];
	$post_meta_values = get_post_custom_values($meta_key, $easy_query->post->ID);

	if(!empty($post_meta_values)){
		//~ show as raw text
		if($show_as == 0){
			$out .= '<div class="'.$class.'">';
			foreach ( $post_meta_values as $key) {
				$out .= $key; 
				$out .= $separator;
			}
			$out .= '</div>';
		}
		//~ show as link to archives
		else{
			$out .='<ul class="'.$class.'">';
			foreach ($post_meta_values as $key) {
				$out .= '<li class="'.$meta_key.'">'.$key.'</li>'; 
				$out .= $separator;
			}
			$out .= '</ul>';
		}
		
	}
	
	return $out;
}

//~ 
//~ Simple text
//~ 
function b2046_textfield($easy_query, $values){
	$value = apply_filters('the_content', $values[0]);
	$class = $values[1];
	$out = '';
	if(!empty($value) && !empty($class)){
		$out .= '<div class="'.$class.'">'.$value.'</div>';
	}elseif(!empty($value)){
		$out .= $value;
	}
	return $out;
}

//~ 
//~ Debug
//~ 
function b2046_query_debug($tmp_query, $values){
	echo '<pre><b>DEBUG:</b><br />';
	var_dump( $tmp_query);
	echo '</pre>';
	$out = array();
	return $out;
}

//~ 
//~ link to archive
//~ 
function b2046_link_to_archive($tmp_query, $values){
	$out = '';
	$type = $values[0];
	$term_name = $values[1];
	$term_id = (int)$values[2];
	$text = $values[3];
	$class = $values[4];
	if($type == 'taxonomy' && !empty($term_name) && !empty($term_id)){
		$term_link = get_term_link( intval($term_id), $term_name );
		$link = !is_wp_error($term_link) ? $term_link : '';

		$out .= '<div class="'.$class.'"><a href="'.$link.'">'.$text.'</a></div>';
	}elseif($type =='post_type'){
		$out .= '<div class="'.$class.'"><a href="'.get_post_type_archive_link($term_name).'">'.$text.'</a></div>';
	}elseif($type =='blog'){
		$out .= '<div class="'.$class.'"><a href="'.get_permalink( get_option( 'page_for_posts' ) ) .'">'.$text.'</a></div>';
	}
	
	return $out;
}

//~ 
//~ Shortcode 
//~ 

function b2046_shortcode($easy_query, $values){
	$value = $values[0];
	$class = $values[1];
	$out = '';
	if(!empty($value) && !empty($class)){
		$out .= '<div class="'.$class.'">'.do_shortcode($value).'</div>';
	}elseif(!empty($value)){
		$out .= do_shortcode($value);
	}
	return $out;
}

//~ 
//~ Comments number
//~ 

function b2046_comments_number($easy_query, $values){
	$class = $values[0];
	$out = '';
	if(!empty($value) && !empty($class)){
		$out .= '<div class="'.$class.'">'.get_comments_number($easy_query->post->ID).'</div>';
	}elseif(!empty($value)){
		$out .= get_comments_number($easy_query->post->ID);
	}
	return $out;
}

//~ 
//~ Comments number
//~ 

function b2046_comments_template($easy_query, $values){
	$class = $values[0];
	$out = '';
	if(!empty($class)){
		$out .= '<div class="'.$class.'">'.comments_template().'</div>';
	}else{
		$out .= comments_template();

	}
	return $out;
}
//~ 
//~ Permissions
//~ 

function b2046_show_post_by_id($easy_query, $values){
	$out = array();
	if(!empty($values)){
		$out = array(
			'post__in' => Easy_2046_builder::f2046_id_cleaner_to_array($values)
			);
	}
	
	return $out;
}

//~ 
//~ Get date of the "post"
//~ 
function b2046_date($easy_query, $values){
	$out = '';
	$type = $values[0];
	//~ $link = $values[0];
	$date_format = $values[1];
	$class = $values[2];
	
	//~ show the published date
	if($type == 'published'){
		if(!empty($date_format)){
			$the_date = get_the_date($date_format);
		}else{
			$the_date = get_the_date('d. M. Y.');
		}
	}
	//~ show modified date
	else{
		if(!empty($date_format)){
			$the_date = get_the_modified_date($date_format);
		}else{
			$the_date = get_the_modified_date('d. M. Y.');
		}
	}
	$out .= '<div class="'.$class.'">';
	$out .= $the_date;
	$out .= '</div>';
	return $out;
	
}

//~ 
//~ Global permission resistor 
//~ 
function b2046_general_visibility($tmp_query, $values){
	global $current_user;
	if (isset($current_user->roles[0])){
		$user_level =  $current_user->roles[0];
	}else{
		$user_level = '';
	}
	
	if($values == 'all' || empty($values) ){
		return true;
		
	}elseif(!empty($user_level) && $user_level >= $values ){
		return true;
	}else{
		return false;
	}
}

//~ 
//~ Show/Hide on view type
//~ 
function b2046_on_condition($tmp_query, $values){
	global $wp_query;
	$output = true;
	//~  do not show on conditions
	if($values[0] == 0 && isset($values[1])){
		//~ check if the values against the global query
		unset($values[0]);
		foreach($values as $val){
			if(isset($wp_query->$val)){
				if($wp_query->$val == 1){
					$output = false;
					break;
				}else{
					$output = true;
				}
			}
		}
	}
	//~ show on conditions
	elseif($values[0] == 1 && isset($values[1])){
		unset($values[0]);
		foreach($values as $val){
			if($wp_query->$val == 1){
				$output = true;
				
			}else{
				$output = false;
				break;
			}
		}
	}
	return $output;
}

//~ 
//~ Show on post, page, what ever id
//~ 
function b2046_on_p_ID($tmp_query, $values){
	// 1 = show
	if($values[0] == '1'){
		$a = true; 
		$b = false;
	}else{
		$a = false; 
		$b = true;
	}

	// if the post id is defined
	if(!empty($values[1])){
		global $post;
		$output = true;
		$pids = Easy_2046_builder::f2046_id_cleaner_to_array($values[1]);
		$object_id = $post->ID;
		foreach($pids as $pid){
			if($object_id == $pid){
				$output = $a;
				break;
			}else{
				$output = $b;
			}
		}
		
	}else{
		$output = true;
	}
	return $output;
}
//~ 
//~ Show/hide on post type
//~ 
function b2046_on_post_type($tmp_query, $values){
	$post_type = $values[0];
	// set decision
	if($values[1] == 'true'){
		$a = true; 
		$b = false;
	}else{
		$a = false; 
		$b = true;
	}

	// if the post type is set
	if(!empty($values[0])){
		global $post;
		$output = true;
		$given_types = Easy_2046_builder::f2046_string_to_array($values[0]);
		$current = $post->post_type;
		if(in_array($current, $given_types)){
			$output = $a;
		}else{
			$output = $b;
		}
		
	}else{
		$output = true;
	}
	return $output;
}
//~ 
//~ CONTROL - posts by author xyz
//~ 
function b2046_by_author($tmp_query, $values){
	$choice = $values[0];
	global $post;
	//  if they want to show the post made by particular author, defined by ids
	if($choice == 0){
		$user_id = $values[1];
	}
	// if the author has to be taken from the current post
	else{
		$user_id = ($post->post_author);
	}

	$args = array(
		'author' => $user_id
		);
	return $args;
}

function b2046_on_taxonomy($tmp_query, $values){
	$output = false;
	$taxonomy = !empty($values[0]) ? $values[0] : 'category';
	$terms = Easy_2046_builder::f2046_id_cleaner_to_array($values[1]);
	$showhide = $values[2];
		
	if($showhide == 'show'){
		$a = true; 
		$b = false;
	}else{
		$a = false; 
		$b = true;
	}
	// get the terms form actual post
	global $post;
	$term_list = wp_get_post_terms($post->ID, $taxonomy, array("fields" => "ids"));
	
	if(!empty($terms)){
		foreach($term_list as $term){
			if(in_array($term, $terms)){
				$output = $a;
				break;
			}else{
				$output = $b;
			}
		}
	}else{
		$output = true;
	}
	return $output;
}
function b2046_on_hierarchy($tmp_query, $values){
	$output = false; // true, false
	$showhide = $values[0]; // show, hide
	$type = $values[1]; // child - On child pages of defined ID, parent - On parent page of defined ID/s 
	$IDs = Easy_2046_builder::f2046_id_cleaner_to_array($values[2]); // page ids (coverted to array)
	$depth = $values[3]; // default 1
	$include_exclude = $values[4]; // 0 - exclude, 1 - include
	global $post;
	$actualID = isset($post->ID) ? $post->ID : '';
	if (!empty($actualID)){
		$closestParent = $post->post_parent;
		if($showhide == 'show'){
			$a = true; 
			$b = false;
		}else{
			$a = false; 
			$b = true;
		}
		
		if(!empty($IDs)){
			// search through on child pages
			if($type == 'child'){

				$onPages = Easy_2046_builder::getChildren($IDs, $depth, $include_exclude);
				// if the actual page is in the the list of allowed pages
				if(in_array($actualID,$onPages)){
					$output = $a;
				}else{
					$output = $b;
				}
				
			}
			// search through parent pages
			else{
				$parents = Easy_2046_builder::getParents($IDs, $depth, $include_exclude);
				if(in_array($actualID,$parents)){
					$output = $a;
				}else{
					$output = $b;
				}
			}
		}
	}
	return $output;
}

//~ 
//~ restrict based on hierarchy
//~ 

function b2046_hierarchy_based($tmp_query, $values){
	//~ '0' => 'Pages from the same level as current page',
	//~ '1' => 'Pages from the same level as given ID',
	//~ '2' => 'Child pages of current page',
	//~ '3' => 'Child pages of given ID'
	$output = array();
	$args = array();
	$choice = $values[0];
	$page_ids = Easy_2046_builder::f2046_id_cleaner_to_array($values[1]);
	if(!empty($values[2])){
		$xclude = $values[2];
	}else{
		$xclude = '';
	}
	$exclude_top_level_pages = (isset($values[3])) ? $values[3] : 0;

	$args_parent = array();
	global $post;

	
	//~ '0' => 'Pages from the same level as current page',
	if($choice == 0){
		if (!empty($post->post_parent)){
			$output['post_parent'] = $post->post_parent;
			if($xclude == '1'){
				$output['post__not_in'] = array($post->ID); 
			}
		}else{
			if($xclude == '1'){
				$output['post__not_in'] = (isset($tmp_query['post__not_in'])) ? array_merge(array($post->ID),$tmp_query['post__not_in'] ) : array($post->ID);
			}
			// if they do wish include top level pages
			if($exclude_top_level_pages != 1){
				//~  if there are no parent, we are in the top level and so will return only top level pages with zero parent
				$output['post_parent'] = '0';
			}else{
				// get top level pages
				$top_level_page_ids = Easy_2046_builder::getTopLevelPages($tmp_query['post_type'], $tmp_query['post_status']);
				// merge if needed, and set top level pages for exclusion
				$output['post__not_in'] = (isset($tmp_query['post__not_in'])) ? array_merge($top_level_page_ids,$tmp_query['post__not_in'] ) : $top_level_page_ids;
			}	
		}
		//~ force the post type to be the same as the current page, or the given page ID
		// $output['post_type'] = $post->post_type;
	//~ '2' => 'Child pages of current page',
	}elseif($choice == 2){
		$output['post_parent'] = $post->ID;
		// $output['post_type'] = $post->post_type;
	}
	//~ '1' => 'Pages from the same level as given ID',
	elseif($choice == 1){
		if (!empty(get_post($page_ids[0])->post_parent)){
			$output['post_parent'] = get_post($page_ids[0])->post_parent;
		}else{
			// if they do not wish not to show top level pages
			if($exclude_top_level_pages != 1){
				$output['post_parent'] = '0';
			}
			else{
				// get top level pages
				$top_level_page_ids = Easy_2046_builder::getTopLevelPages($tmp_query['post_type'], $tmp_query['post_status']);
				// merge if needed, and set top level pages for exclusion
				$output['post__not_in'] = (isset($tmp_query['post__not_in'])) ? array_merge($top_level_page_ids,$tmp_query['post__not_in'] ) : $top_level_page_ids;
			}
		}
		//  $output['post_type'] = get_post_type($page_ids[0]);
		if($xclude == 1){
			$output['post__not_in'] = (isset($tmp_query['post__not_in'])) ? array_merge(array($page_ids[0]),$tmp_query['post__not_in'] ) : array($page_ids[0]);
		}
	}
	//~ '3' => 'Child pages of given ID'
	elseif($choice == 3){
		$output['post_parent'] = $page_ids[0];
		// $output['post_type'] = get_post_type($page_ids[0]);
	}

	return $output;
}

//~ 
//~ navigation - View
//~ 
function b2046_WP_pagenavi($easy_query, $values){
	$output = '';
	ob_start();
	if(function_exists ('wp_pagenavi')){
		wp_pagenavi( array( 'query' => $easy_query ) );
		$output = ob_get_clean();
		wp_reset_postdata();	// avoid errors further down the page
	}
	return $output;
}

// Previous post on current Easy loop
function b2046_previous_posts_link($easy_query, $values){
	
	$output = '';
	$previous_post_obj = get_previous_post();

	// if previous post exists
	if(isset($previous_post_obj->ID)){
		$text = $values[0];
		$class = $values[1];
		if(!empty($class)){
			$output .= '<div class="'.$class.'">';
		}
			//  check if they do not want to use their own string
		if(!empty($text)){$text_string = $text;}else{$text_string = $previous_post_obj->post_title;}
		$output .= '<a href="'.get_permalink( $previous_post_obj->ID ).'">'.$text_string.'</a>';
		
		if(!empty($class)){
			$output .= '</div>';
		}
	}
	return $output;
}
// Next post on current Easy loop
function b2046_next_posts_link($easy_query, $values){
	$output = '';
	$next_post_obj = get_next_post();
	// if the next page exist
	if(isset($next_post_obj->ID)){
		$text = $values[0];
		$class = $values[1];
		if(!empty($class)){
			$output .= '<div class="'.$class.'">';
		}
			//  check if they do not want to use their own string
		if(!empty($text)){$text_string = $text;}else{$text_string = $next_post_obj->post_title;}
		$output .= '<a href="'.get_permalink( $next_post_obj->ID ).'">'.$text_string.'</a>';
		if(!empty($class)){
			$output .= '</div>';
		}
	}
	return $output;
}

// Next post on current Easy loop
function b2046_posts_nav_link($easy_query, $values){
	$output = '';
	$separator = (empty($values[0])) ? '&#8212;' : $values[0];
	$prevlabel = (empty($values[1])) ? __('&laquo; Previous Page') : $values[1];
	$nextlabel = (empty($values[2])) ? __('Next Page &raquo;') : $values[2];
	$class =     (empty($values[3])) ? 'post_nav_link'          : $values[3];
	
	$output = '<div class="'.$class.'">'.get_previous_posts_link($prevlabel) . $separator . get_next_posts_link($nextlabel).'</div>';

	return $output;
}

//~ 
//~ CONTROL - finds the actual post id and ad it to the query
//~ 
function b2046_exclude_actual($tmp_query, $values){	
	// get the global post object
	global $post;
	// check if the post__not_in is not empty, if not then combine what we got already with the actual post
	if(!empty($tmp_query['post__not_in'])){
		$id_array = array_push($tmp_query['post__not_in'], $post->ID);
	}
	// 
	else{
		$id_array = array($post->ID);
	}

	$args = array(
		'post__not_in' => $id_array
		);
	return $args;
}
function b2046_bootstrap_menu($easy_query, $values){
	$location = (!empty($values[0]) ? $values[0] : 'primary');
	$name = $values[1];
	$class = $values[2];

 $output = wp_nav_menu( array(
 		'echo' => 0,
        'menu'              => $name,
        'theme_location'    => $location,
        'depth'             => 2,
        'container'         => 'div',
        'container_class'   => $class.' collapse navbar-collapse',
		'container_id'      => 'bs-example-navbar-collapse-1',
        'menu_class'        => 'nav navbar-nav',
        'fallback_cb'       => 'wp_bootstrap_navwalker::fallback',
        'walker'            => new Easy_bootstrap_navwalker()
        )
    );
 return $output;
}
//~  post status
function b2046_post2post($tmp_query, $values){
	$connection_type = $values[1];
	$output = array();
	$args = array(
		'connected_type' => $connection_type,
  		'connected_items' => get_queried_object(),
		);
		//~ rewrite the default data with our own
	$output =  $args;
	return $output;
}